
/* -------------------------------- main.c --------------------------------- */

/* maximizer / limiter v1.1.0 (Jul 10 2000)	*/
/* written by Istvan Varga 1999, 2000		*/

#include "main.h"
#include "maximizer.h"
#include "fileio.h"
#include "getparams.h"
#include "def_params.h"

int	argc;
char	**argv;
float	tmpblockx[ALLBLKSIZE << 1];
int	fpos, i;

char	program_name[16] = "maximizer";
char	stdin_name[16] = "standard input";
char	stdout_name[16] = "standard output";

/* ------------------------------------------------------------------------- */

int	main (int argctmp, char **argvtmp)
{
	argc = argctmp;
	argv = argvtmp;

	argv[0] = program_name;

	setbuf (stderr, NULL);

	if (argc < 3) {
		PrintVersion ();
		PrintUsage ();	/* print usage */
		exit (0);
	}

	if (argc > 3)
		GetParams ();	/* read command line options */

	if (v_mode)
		PrintVersion ();

	/* open input and output file */

	if ( ! (strcmp (argv[1], "-"))) {
		infile = STDIN_FILENO;		/* read from standard input */
		argv[1] = stdin_name;
	} else {
		infile = open (argv[1], O_RDONLY);
		if (infile == -1) {
			fprintf (stderr, "%s: cannot open %s: %s\n",
					argv[0], argv[1], strerror (errno) );
			exit (-1);
		}
	}

	if ( ! (strcmp (argv[2], "-"))) {
		outfile = STDOUT_FILENO;	/* write to standard output */
		argv[2] = stdout_name;
	} else {
		outfile = open (argv[2], O_WRONLY | O_CREAT | O_TRUNC, 0644);
		if (outfile == -1) {
			fprintf (stderr, "%s: cannot open %s: %s\n",
					argv[0], argv[2], strerror (errno) );
			exit (-1);
		}
	}

	CheckParameters ();	/* check parameters */

	fsize = 0x7FFFFFFF;	/* fsize = file size in samples */
	fsize2 = 0;
	fpos = 0;		/* fpos = file position in samples */

	InitFilters ();		/* initialize filters used by ErrPower */

	do {	if (v_mode)
			fprintf (stderr, "\r%.1f seconds        ",
					(float) fpos / esr);

		for (i = 0; i < (ALLBLKSIZE<<1); i++) tmpblockx[i] = 0.0;

		ReadBlock (fpos - (MAXBLKSIZE << 1), tmpblockx);
		MaximizeBlock2 (tmpblockx);
		WriteBlock (fpos, tmpblockx + (MAXBLKSIZE << 2));

		fpos += ALLBLKSIZ2;

	} while (fpos < fsize);

	if (v_mode)
		fprintf(stderr,"\r%.1f seconds        \n",
				(float) fsize / esr);

	/* close input and output file */

	if (infile != STDIN_FILENO) {
		i = close (infile);
		if (i == -1) {
			fprintf (stderr, "%s: error closing %s: %s\n",
					argv[0], argv[1], strerror (errno) );
			exit (-1);
		}
	}

	if (outfile != STDOUT_FILENO) {
		i = close (outfile);
		if (i == -1) {
			fprintf (stderr, "%s: error closing %s: %s\n",
					argv[0], argv[2], strerror (errno) );
			exit (-1);
		}
	}

	return 0;
}


